// GouraudView.cpp : implementation of the CGouraudView class
//

#include "stdafx.h"
#include "math.h"
#include "string.h"
#include "Gouraud.h"
#include "VnosDlg.h"
#include "Data.h"

#include "GouraudDoc.h"
#include "GouraudView.h"

// Definicije globalnih spremenljivk


struct Vektor 
	{
		double x;
		double y;
		double z;
	};
	
struct Tocka
	{
		double Intenziteta;
		int x;
		int y;
		int z;
		short StRobu;
		
	};

	double IntOgl[4];
	int StVrstic, StVsehTock;

	Tocka Rob[500];
	Tocka Tocke[50000];
	Vektor Ogl[4]; 
	Vektor VirSvetlobe;

	void IntenzitetaTocke(const Tocka[]);
	void RobSort(Tocka[], int);
	Vektor Normal (Vektor);
	double Skalar (Vektor, Vektor);
	Vektor VektProdukt (Vektor, Vektor);
	Vektor VektOdst (Vektor, Vektor);



//Konec definicij

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGouraudView

IMPLEMENT_DYNCREATE(CGouraudView, CView)

BEGIN_MESSAGE_MAP(CGouraudView, CView)
	//{{AFX_MSG_MAP(CGouraudView)
	ON_COMMAND(ID_GOURAUD_PRIKAZI, OnGouraudPrikazi)
	ON_COMMAND(ID_GOURAUD_SENCENJE, OnGouraudSencenje)
	ON_COMMAND(ID_GOURAUD_VNOSPODATKOV, OnGouraudVnospodatkov)
	ON_COMMAND(ID_GOURAUD_IZHOD, OnGouraudIzhod)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGouraudView construction/destruction

CGouraudView::CGouraudView()
{
	// TODO: add construction code here


	Data::Create();
	


}

CGouraudView::~CGouraudView()
{
	Data::Destroy();
}

BOOL CGouraudView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGouraudView drawing

void CGouraudView::OnDraw(CDC* pDC)
{
	CGouraudDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CGouraudView printing

BOOL CGouraudView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CGouraudView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CGouraudView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CGouraudView diagnostics

#ifdef _DEBUG
void CGouraudView::AssertValid() const
{
	CView::AssertValid();
}

void CGouraudView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGouraudDoc* CGouraudView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGouraudDoc)));
	return (CGouraudDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGouraudView message handlers








void CGouraudView::OnGouraudPrikazi() 
{
	
StVrstic = 0;

	
	
	CClientDC dc(this);
	
	RedrawWindow();

	dc.TextOut( 10, 10, "MIHA Janei", 12 );
	dc.TextOut( 10, 25, "Vaje RPK 98/99", 14 );

	dc.TextOut(VirSvetlobe.x,VirSvetlobe.y,"Luc",3);

	
	Trikotnik(Ogl[1].x,Ogl[1].y,Ogl[2].x,Ogl[2].y,Ogl[3].x,Ogl[3].y);	//doloitev trikotnika
	Izris();	//izris robov trikotnika
	IntenzitetaOgljisc();	//izraun intenzitete oglji
	RobSort(Rob,StVrstic);	//sortiranje koordinat robov - priprava na senenje!

	
}


void CGouraudView::OnGouraudSencenje() 
{
int i;


	Peresa(true);
	
	IntenzitetaTocke(Rob);

	RedrawWindow();


	for (i=0;i <= StVsehTock ;i++)
	{
		Pika(Tocke[i].x, Tocke[i].y,1,(Tocke[i].Intenziteta));
	}

	Peresa(false);

	IzpisVhodnihPodatkov(10,10);
	
}



void RobSort(Tocka A[], int Velikost)
{
int i,j;

Tocka C[500], Maks;

// iskanje maksimuma
	C[Velikost-1] = A[0];
	for (i=0;i < Velikost;i++)
	{
		if (A[i].y > C[Velikost-1].y) {C[Velikost-1] = A[i];}
	}

	Maks = C[Velikost-1];

// Sortiranje po Y koordinati
	for (j = 0;j < Velikost;j++)
	{
		C[j] = Maks;
		
		for (i=0;i < Velikost;i++)
		{
			if (A[i].y < C[j].y && A[i].y > C[j-1].y && A[i].x != C[j-1].x)
			{
				C[j] = A[i];
			}
			else if (A[i].y < C[j].y && A[i].y == C[j-1].y && A[i].x != C[j-1].x && A[i].y != C[j-2].y)
			{
				C[j] = A[i];
			}
			else if (C[j].x == C[j-1].x && C[j].x == C[j-1].x && i == Velikost-1)
			{
				Velikost--;
				j--;
			}
		}
	}
	
	

	
	StVrstic = Velikost;
	
	FILE *fp;
	fp = fopen("test.out","w");
	
	for(i=0;i < StVrstic; i++)
	{
		A[i] = C[i];
		fprintf(fp," x = %i, y = %i, z = %i, StRobu = %i \n", A[i].x, A[i].y, A[i].z, A[i].StRobu);
	}

	fclose(fp);
}


//Izraun tok za polnjenje trikotnika
void IntenzitetaTocke(const Tocka A[])	// A... po vrsti urejene tocke robu
{
	int i=0,j=0,k=0,l=0, Og1, Og2;
	FILE *fp;
	double a,b;
	StVsehTock = 0;
	for (i=1; i < StVrstic-1; i+=2)
	{
		j=i+1;

	
	
		
		if(A[i].StRobu ==1) {Og1 = 1; Og2 = 2;}
		else if(A[i].StRobu ==2) {Og1 = 2; Og2 = 3;}
		else if(A[i].StRobu ==3) {Og1 = 3; Og2 = 1;}
				
		k=k+1;	
				
		Tocke[k].x = A[i].x;
		Tocke[k].y = A[i].y;
		Tocke[k].z = A[i].z;
		a = Tocke[k].x;

		Tocke[k].Intenziteta = 1/(Ogl[Og1].y - Ogl[Og2].y)*(IntOgl[Og1]*(A[i].y-Ogl[Og2].y) + IntOgl[Og2]*(Ogl[Og1].y-A[i].y));
		
		if(A[j].StRobu ==1) {Og1 = 1; Og2 = 2;}
		else if(A[j].StRobu ==2) {Og1 = 2; Og2 = 3;}
		else if(A[j].StRobu ==3) {Og1 = 3; Og2 = 1;}
		
		k=k+1;

		Tocke[k].x = A[j].x;
		Tocke[k].y = A[j].y;
		Tocke[k].z = A[j].z;
		b = Tocke[k].x;	

		Tocke[k].Intenziteta = 1/(Ogl[Og1].y - Ogl[Og2].y)*(IntOgl[Og1]*(A[j].y-Ogl[Og2].y) + IntOgl[Og2]*(Ogl[Og1].y-A[j].y));

		
		for (l = k + 1;l <= k + abs(a-b)-1;l++)
		{
			Tocke[l].x = min(Tocke[k].x,Tocke[k-1].x) + l-k;
			Tocke[l].y = Tocke[k].y;
			Tocke[l].Intenziteta = 1/(b-a)*(Tocke[k-1].Intenziteta*(b-Tocke[l].x)+Tocke[k].Intenziteta*(Tocke[l].x-a));



		}
		k=l-1;
	}

	StVsehTock = k;

	fp = fopen("koncni.out","w");

	for (i=1; i <= k;i+=2)
	{
		j=i+1;
		fprintf(fp," \t %i \t %i \t  %i \t %f   \n",i,Tocke[i].x,Tocke[i].y,Tocke[i].Intenziteta);
		fprintf(fp," \t %i \t %i \t  %i \t %f   \n",j,Tocke[j].x,Tocke[j].y,Tocke[j].Intenziteta);
	}



	fclose(fp);






}




void CGouraudView::Pika(int x, int y, int d, double Intenziteta)

{

	int i = 255*(Intenziteta);
	
	CClientDC dc(this);

	dc.SelectObject(&Pen[i]);

	dc.MoveTo(x+1,y+1);
	dc.LineTo(x,y);

	afxDump << "Pen = " << i <<"\n";

}









void CGouraudView::Crta(double x1, double y1, double x2, double y2, short ZapSt)
{
	
double x,y,k,n;
double temp, temp1;	
	if (y1>y2)
	{
		temp=y1;
		y1=y2;
		y2=temp;

		temp=x1;
		x1=x2;
		x2=temp;
	}

	x = x1;
	
	k = (x2-x1)/(y2-y1);
	n = x1-(k*y1);

		for(y=y1; y <= y2; y++)

		{
			
			x = k * y + n;

			if (modf(x,&temp1)>.5) {x = x+1;}



			ZapisTocke(x,y,StVrstic,ZapSt);
			
			StVrstic=StVrstic+1;
		
		}
}





void CGouraudView::Trikotnik(double x1, double y1, double x2, double y2, double x3, double y3)
{
	
	Crta(x1,y1,x2,y2,1);
	Crta(x2,y2,x3,y3,2);
	Crta(x3,y3,x1,y1,3);

}






void CGouraudView::ZapisTocke(int x, int y, int stev, short ZapSt)
{
	
	Rob[stev].x = x;
	Rob[stev].y = y;
	Rob[stev].StRobu = ZapSt;

}



void CGouraudView::Izris(void)
{
FILE *fp;

fp = fopen ("Gouraud.out","w");
	
	int i=0;
	for (i=0;i<StVrstic;i++)
	{
		Pika(Rob[i].x,Rob[i].y,1,0);
		fprintf(fp,"%i, %i \n",Rob[i].x,Rob[i].y);
	}
fclose(fp);
}

void CGouraudView::IntenzitetaOgljisc(void)
{
FILE *fp;

fp = fopen("int1.out","w");

Vektor A,B,C,D,E,F;




	A = Normal(VektProdukt(VektOdst(Ogl[3],Ogl[1]),VektOdst(Ogl[2],Ogl[1])));
	B = Normal(VektProdukt(VektOdst(Ogl[1],Ogl[2]),VektOdst(Ogl[3],Ogl[2])));
	C = Normal(VektProdukt(VektOdst(Ogl[2],Ogl[3]),VektOdst(Ogl[1],Ogl[3])));

	D = Normal(VektOdst(VirSvetlobe,Ogl[1]));
	E = Normal(VektOdst(VirSvetlobe,Ogl[2]));
	F = Normal(VektOdst(VirSvetlobe,Ogl[3]));

	IntOgl[1] = Skalar(D,A);
	IntOgl[2] = Skalar(E,B);
	IntOgl[3] = Skalar(F,C);
	
	fprintf(fp,"\n Intenziteta ogljisca 1 I(%f,%f) = %f \n", Ogl[1].x, Ogl[1].y, IntOgl[1]);
	fprintf(fp,"\n Intenziteta ogljisca 2 I(%f,%f) = %f \n", Ogl[2].x, Ogl[2].y, IntOgl[2]);
	fprintf(fp,"\n Intenziteta ogljisca 3 I(%f,%f) = %f \n", Ogl[3].x, Ogl[3].y, IntOgl[3]);
	
fclose(fp);
}



void CGouraudView::OnGouraudVnospodatkov() 
{
	CVnosDlg vnosDlg;
	vnosDlg.DoModal();


	Ogl[1].x = Data::pData->edit1;
	Ogl[1].y = Data::pData->edit4;	
	Ogl[1].z = Data::pData->edit7;
	Ogl[2].x = Data::pData->edit2;
	Ogl[2].y = Data::pData->edit5;
	Ogl[2].z = Data::pData->edit8;
	Ogl[3].x = Data::pData->edit3;
	Ogl[3].y = Data::pData->edit6;
	Ogl[3].z = Data::pData->edit9;
	VirSvetlobe.x = Data::pData->edit10;
	VirSvetlobe.y = Data::pData->edit11;
	VirSvetlobe.z = Data::pData->edit12;





}



Vektor Normal (Vektor A) //normalizacija vektorja
{
Vektor C;
	
	C.x = A.x/(sqrt(A.x*A.x+A.y*A.y+A.z*A.z));
	C.y = A.y/(sqrt(A.x*A.x+A.y*A.y+A.z*A.z));
	C.z = A.z/(sqrt(A.x*A.x+A.y*A.y+A.z*A.z));


return C;
}


double Skalar (Vektor A, Vektor B) //skalarni produkt dveh vektorjev
{
double c;

	c = A.x*B.x+A.y*B.y+A.z*B.z;


return c;
}



Vektor VektProdukt (Vektor A, Vektor B)	// Vektorski produkt dveh vektorjev
{
Vektor C;

	C.x = A.y*B.z - A.z*B.y;
	C.y = A.z*B.x - A.x*B.z;
	C.z = A.x*B.y - A.y*B.x;

return C;
}


Vektor VektOdst (Vektor A, Vektor B)	//Vektorsko odstevanje

{
Vektor C;
	
	C.x = A.x - B.x;
	C.y = A.y - B.y;
	C.z = A.z - B.z;

return C;
};

void CGouraudView::Peresa(bool bl)
{
int i;
double r, g, b;

r = Data::pData->Red;
g = Data::pData->Green;
b = Data::pData->Blue;


	if (bl == true)
	{
		for (i=0; i<256; i++)
		{
			Pen[i].CreatePen (PS_SOLID, 1, RGB(i*r/100,i*g/100,i*b/100));
		}
	}

	else
	{
		for (i=0; i<256; i++)
		{
			Pen[i].DeleteObject();
		}
	}
}
void CGouraudView::OnGouraudIzhod() 
{
}

void CGouraudView::IzpisVhodnihPodatkov(int x, int y)
{

	int r = 15;
	CString A;
	CClientDC dc(this);

// IZPIS OGLJISC


	

}
